org.apache.uima.fit.factory

## Class AnalysisEngineFactory

- java.lang.Object
- - org.apache.uima.fit.factory.AnalysisEngineFactory

-     public final class AnalysisEngineFactory
      extends Object

  A collection of static methods for creating UIMA `AnalysisEngineDescriptions` and `AnalysisEngines`.
  See Also:
    Why are descriptors better than component instances?

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAggregate(org.apache.uima.analysis_engine.AnalysisEngineDescription desc)` Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAggregate(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[])`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAggregate(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAggregate(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription, Object... configurationData)` Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAggregate(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, Object... configurationData)` Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAggregateDescription(org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)` Deprecated. use `createEngineDescription(AnalysisEngineDescription...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAggregateDescription(org.apache.uima.flow.FlowControllerDescription flowControllerDescription, org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)` Deprecated. use `createEngineDescription(FlowControllerDescription, AnalysisEngineDescription...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAggregateDescription(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAggregateDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription, Object... configurationData)` Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAggregateDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, Object... configurationData)` Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAnalysisEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription analysisEngineDescription, String viewName)` Deprecated. use `createEngine(AnalysisEngineDescription, String)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAnalysisEngine(String descriptorName, Object... configurationData)` Deprecated. use `createEngine(String, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAnalysisEngineDescription(String descriptorName, Object... configurationData)` Deprecated. use `createEngineDescription(String, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createAnalysisEngineDescriptionFromPath(String descriptorPath, Object... configurationData)` Deprecated. use `createEngineDescriptionFromPath(String, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createAnalysisEngineFromPath(String descriptorPath, Object... configurationData)` Deprecated. use `createEngineFromPath(String, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription desc, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription analysisEngineDescription, String viewName)` This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, String[] typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngine(String descriptorName, Object... configurationData)` Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters, Object[] configurationValues)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters, Object[] configurationValues, Map<String,org.apache.uima.resource.ExternalResourceDescription> externalResources)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(org.apache.uima.flow.FlowControllerDescription flowControllerDescription, org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)` A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription)` A factory method for creating an aggregate description.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, org.apache.uima.flow.FlowControllerDescription flowControllerDescription, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(org.apache.uima.resource.PearSpecifier pearSpecifier, Object... configurationData)` Get an `AnalysisEngineDescription` from a PEAR and a set of configuration parameters.
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescription(String descriptorName, Object... configurationData)` Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createEngineDescriptionFromPath(String descriptorPath, Object... configurationData)` Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createEngineFromPath(String descriptorPath, Object... configurationData)` Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createPrimitive(org.apache.uima.analysis_engine.AnalysisEngineDescription desc, Object... configurationData)` Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, Object... configurationData)` Deprecated. use `createEngine(Class, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, String[] typePriorities, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, String[], Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngine` | `createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, TypePriorities, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, Object... configurationData)` Deprecated. use `createEngineDescription(Class, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters, Object[] configurationValues)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[])`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters, Object[] configurationValues, Map<String,org.apache.uima.resource.ExternalResourceDescription> externalResources)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[], Map)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, org.apache.uima.resource.metadata.FsIndexCollection indexes, org.apache.uima.resource.metadata.Capability[] capabilities, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], Object...)`
    `static org.apache.uima.analysis_engine.AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass, org.apache.uima.resource.metadata.TypeSystemDescription typeSystem, org.apache.uima.resource.metadata.TypePriorities typePriorities, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, Object...)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(String descriptorName,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.util.InvalidXMLException,
                                                                                    IOException,
                                                                                    org.apache.uima.resource.ResourceInitializationException

      Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        the `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAnalysisEngine

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAnalysisEngine(String descriptorName,
                                                                                                        Object... configurationData)
                                                                                                 throws org.apache.uima.util.InvalidXMLException,
                                                                                                        IOException,
                                                                                                        org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(String, Object...)`
      Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        the `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription analysisEngineDescription,
                                                                                    String viewName)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
      Parameters:
        `analysisEngineDescription` - the analysis engine description from which the engine is instantiated
        `viewName` - the view name to map the default view to
      Returns:
        an aggregate analysis engine consisting of a single component whose default view is mapped to the the view named by viewName.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?, `AggregateBuilder`

    - #### createAnalysisEngine

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAnalysisEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription analysisEngineDescription,
                                                                                                        String viewName)
                                                                                                 throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, String)`
      This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
      Parameters:
        `analysisEngineDescription` - the analysis engine description from which the engine is instantiated
        `viewName` - the view name to map the default view to
      Returns:
        an aggregate analysis engine consisting of a single component whose default view is mapped to the the view named by viewName.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?, `AggregateBuilder`

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(org.apache.uima.analysis_engine.AnalysisEngineDescription desc,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAggregate(org.apache.uima.analysis_engine.AnalysisEngineDescription desc)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
      Create an aggregate `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createPrimitive(org.apache.uima.analysis_engine.AnalysisEngineDescription desc,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(Class, Object...)`
      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                    org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                   org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                    org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                    String[] typePriorities,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities as an array of type names (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                   org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                   String[] typePriorities,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, String[], Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities as an array of type names (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                    org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                    org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createPrimitive(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                   org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                   org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, TypePriorities, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                    org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                    org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                    org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAggregate(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                   org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                   org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                   org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                    org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                    org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                    org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                    org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                    Object... configurationData)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAggregate(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                   org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                   org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                   org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                   org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                                   Object... configurationData)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                    List<String> componentNames,
                                                                                    org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                    org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAggregate(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                                   List<String> componentNames,
                                                                                                   org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                   org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[])`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngine(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                    List<String> componentNames,
                                                                                    org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                    org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                    org.apache.uima.flow.FlowControllerDescription flowControllerDescription)
                                                                             throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAggregate(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                                   List<String> componentNames,
                                                                                                   org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                   org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                   org.apache.uima.flow.FlowControllerDescription flowControllerDescription)
                                                                                            throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngineFromPath

          public static org.apache.uima.analysis_engine.AnalysisEngine createEngineFromPath(String descriptorPath,
                                                                                            Object... configurationData)
                                                                                     throws org.apache.uima.util.InvalidXMLException,
                                                                                            IOException,
                                                                                            org.apache.uima.resource.ResourceInitializationException

      Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAnalysisEngineFromPath

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngine createAnalysisEngineFromPath(String descriptorPath,
                                                                                                                Object... configurationData)
                                                                                                         throws org.apache.uima.util.InvalidXMLException,
                                                                                                                IOException,
                                                                                                                org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineFromPath(String, Object...)`
      Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngineDescriptionFromPath

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescriptionFromPath(String descriptorPath,
                                                                                                                  Object... configurationData)
                                                                                                           throws org.apache.uima.util.InvalidXMLException,
                                                                                                                  IOException

      Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(org.apache.uima.resource.PearSpecifier pearSpecifier,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.util.InvalidXMLException,
                                                                                                          IOException

      Get an `AnalysisEngineDescription` from a PEAR and a set of configuration parameters.
      Parameters:
        `pearSpecifier` - The PEAR specifier.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createAnalysisEngineDescriptionFromPath

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAnalysisEngineDescriptionFromPath(String descriptorPath,
                                                                                                                                      Object... configurationData)
                                                                                                                               throws org.apache.uima.util.InvalidXMLException,
                                                                                                                                      IOException

      Deprecated. use `createEngineDescriptionFromPath(String, Object...)`
      Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(String descriptorName,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.util.InvalidXMLException,
                                                                                                          IOException

      Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. Will override configuration parameter settings in the descriptor file
      Returns:
        a description for this analysis engine.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createAnalysisEngineDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAnalysisEngineDescription(String descriptorName,
                                                                                                                              Object... configurationData)
                                                                                                                       throws org.apache.uima.util.InvalidXMLException,
                                                                                                                              IOException

      Deprecated. use `createEngineDescription(String, Object...)`
      Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. Will override configuration parameter settings in the descriptor file
      Returns:
        a description for this analysis engine.
      Throws:
        `IOException` - if an I/O error occurs
        `org.apache.uima.util.InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, Object...)`
      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                          org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. In addition to parameter names, external resource keys can also be specified. The value has to be an `ExternalResourceDescription` in that case.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                                         org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. In addition to parameter names, external resource keys can also be specified. The value has to be an `ExternalResourceDescription` in that case.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                          org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                          org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters,
                                                                                                          Object[] configurationValues)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                                         org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                                         org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters,
                                                                                                                         Object[] configurationValues)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[])`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                          org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                          org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters,
                                                                                                          Object[] configurationValues,
                                                                                                          Map<String,org.apache.uima.resource.ExternalResourceDescription> externalResources)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is set explicitly here, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
        `externalResources` - external resources to bind to the analysis engine. (may be null)
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createPrimitiveDescription(Class<? extends org.apache.uima.analysis_component.AnalysisComponent> componentClass,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.resource.metadata.FsIndexCollection indexes,
                                                                                                                         org.apache.uima.resource.metadata.Capability[] capabilities,
                                                                                                                         org.apache.uima.resource.metadata.ConfigurationParameter[] configurationParameters,
                                                                                                                         Object[] configurationValues,
                                                                                                                         Map<String,org.apache.uima.resource.ExternalResourceDescription> externalResources)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[], Map)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is set explicitly here, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
        `externalResources` - external resources to bind to the analysis engine. (may be null)
      Returns:
        a description for this analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAggregateDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAggregateDescription(org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(AnalysisEngineDescription...)`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                          org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                          org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                                          Object... configurationData)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAggregateDescription(List<Class<? extends org.apache.uima.analysis_component.AnalysisComponent>> componentClasses,
                                                                                                                         org.apache.uima.resource.metadata.TypeSystemDescription typeSystem,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                                         org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                                                         Object... configurationData)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                                          org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
      Parameters:
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAggregateDescription(org.apache.uima.flow.FlowControllerDescription flowControllerDescription,
                                                                                                                         org.apache.uima.analysis_engine.AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngineDescription(FlowControllerDescription, AnalysisEngineDescription...)`
      A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
      Parameters:
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createEngineDescription(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                                          List<String> componentNames,
                                                                                                          org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                          org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                          org.apache.uima.flow.FlowControllerDescription flowControllerDescription)
                                                                                                   throws org.apache.uima.resource.ResourceInitializationException

      A factory method for creating an aggregate description.
      Parameters:
        `analysisEngineDescriptions` - list of analysis engine descriptions.
        `componentNames` - list of component names - must be one name per description!
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static org.apache.uima.analysis_engine.AnalysisEngineDescription createAggregateDescription(List<org.apache.uima.analysis_engine.AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                                                         List<String> componentNames,
                                                                                                                         org.apache.uima.resource.metadata.TypePriorities typePriorities,
                                                                                                                         org.apache.uima.analysis_engine.metadata.SofaMapping[] sofaMappings,
                                                                                                                         org.apache.uima.flow.FlowControllerDescription flowControllerDescription)
                                                                                                                  throws org.apache.uima.resource.ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
      A factory method for creating an aggregate description.
      Parameters:
        `analysisEngineDescriptions` - list of analysis engine descriptions.
        `componentNames` - list of component names - must be one name per description!
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `org.apache.uima.resource.ResourceInitializationException` - if a failure occurred during production of the resource.

Copyright © 2012–2020 The Apache Software Foundation. All rights reserved.